package gregapi.cover.covers;

import static gregapi.data.CS.F;
import gregapi.cover.CoverData;
import gregapi.old.Textures;
import gregapi.render.BlockTextureDefault;
import gregapi.render.BlockTextureMulti;
import gregapi.render.ITexture;
import gregapi.tileentity.machines.ITileEntityRunningActively;
import gregapi.tileentity.machines.ITileEntityRunningPossible;
import gregapi.tileentity.machines.ITileEntitySwitchableOnOff;

import java.util.List;

import net.minecraft.entity.Entity;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 */
public class CoverAutoSwitch extends AbstractCoverDefault {
	@Override
	public void onTickPost(byte aSide, CoverData aData, long aTimer, boolean aIsServerSide) {
		if (aIsServerSide && aData.mTileEntity instanceof ITileEntityRunningPossible && aData.mTileEntity instanceof ITileEntitySwitchableOnOff) ((ITileEntitySwitchableOnOff)aData.mTileEntity).setStateOnOff(((ITileEntityRunningPossible)aData.mTileEntity).getStateRunningPossible() || (aData.mTileEntity instanceof ITileEntityRunningActively && ((ITileEntityRunningActively)aData.mTileEntity).getStateRunningActively()));
	}
	
	@Override public boolean onCoverClickedLeft (byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return F;}
	@Override public boolean onCoverClickedRight(byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return F;}
	@Override public boolean interceptClickLeft (byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return F;}
	@Override public boolean interceptClickRight(byte aSide, CoverData aData, Entity aPlayer, byte aSideClicked, float aHitX, float aHitY, float aHitZ) {return F;}
	@Override public ITexture getCoverTextureSurface(byte aSide, CoverData aData) {return sTextureForeground;}
	@Override public ITexture getCoverTextureAttachment(byte aSide, CoverData aData, byte aTextureSide) {return aSide != aTextureSide ? sTextureBackground : BlockTextureMulti.get(sTextureBackground, sTextureForeground);}
	@Override public ITexture getCoverTextureHolder(byte aSide, CoverData aData, byte aTextureSide) {return sTextureBackground;}
	@Override public void addToolTips(List aList, ItemStack aStack, boolean aF3_H) {super.addToolTips(aList, aStack, aF3_H);}
	@Override public boolean isSolid(byte aSide, CoverData aData) {return F;}
	@Override public boolean isOpaque(byte aSide, CoverData aData) {return F;}
	
	public static final ITexture sTextureBackground = BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/autoswitch/base")), sTextureForeground = BlockTextureDefault.get(new Textures.BlockIcons.CustomIcon("machines/covers/autoswitch/circuit"));
}